// ChatSView.cpp : implementation of the CChatSView class
//

#include "stdafx.h"
#include "ChatS.h"

#include "ChatSDoc.h"
#include "ChatSView.h"
#include "DialogStart.h"

#include "ProtocolUnit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatSView

IMPLEMENT_DYNCREATE(CChatSView, CFormView)

BEGIN_MESSAGE_MAP(CChatSView, CFormView)
	//{{AFX_MSG_MAP(CChatSView)
	ON_BN_CLICKED(IDC_START_BUTTON, OnStartButtonClick)
	ON_BN_CLICKED(IDC_STOP_BUTTON, OnStopButtonClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatSView construction/destruction

CChatSView::CChatSView()
	: CFormView(CChatSView::IDD)
{
	//{{AFX_DATA_INIT(CChatSView)
	m_sSaid = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CChatSView::~CChatSView()
{
}

void CChatSView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatSView)
	DDX_Control(pDX, IDC_SAID_EDIT, m_Said_control);
	DDX_Control(pDX, IDC_NICK_LIST, m_NickList);
	DDX_Text(pDX, IDC_SAID_EDIT, m_sSaid);
	//}}AFX_DATA_MAP
}

BOOL CChatSView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CChatSView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit(FALSE);  
}

/////////////////////////////////////////////////////////////////////////////
// CChatSView diagnostics

#ifdef _DEBUG
void CChatSView::AssertValid() const
{
	CFormView::AssertValid();
}

void CChatSView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CChatSDoc* CChatSView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CChatSDoc)));
	return (CChatSDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChatSView message handlers

void CChatSView::OnStartButtonClick() 
{
	// TODO: Add your control notification handler code here

	ScrollEdit();
	CDialogStart dlg;
	if (!GetDocument()->IsServerRunning())
	{
		if (dlg.DoModal()==IDOK)
			GetDocument()->StartServer(dlg.m_nPort);
	}
	else
	{
		m_sSaid+="Server is already running.\r\n";
		UpdateData(FALSE);
	}
}


void CChatSView::ShowClientNicks()
{
	CChatSDoc* pDoc = GetDocument();
	CString sList = pDoc->GetNickList();
	int nPos;
	CString sNick;

	m_NickList.ResetContent(); // kasuje elementy listy
	
	nPos = sList.Find(' ');
	do
	{
		if(nPos == -1)
		{
			if(sList.GetLength()>0)
				m_NickList.AddString(sList);
			return;
		}

		sNick = sList.Left(nPos);
		if(sNick.GetLength()>0)
			m_NickList.AddString(sNick);
		sList = sList.Mid(nPos+1);
		nPos = sList.Find(' ');
	} while(nPos != -1);
}

void CChatSView::OnStopButtonClick() 
{
	ScrollEdit();
	if (GetDocument()->IsServerRunning())
	{
		GetDocument()->SayToAll("DOWN Server is going down....\r\n");
		m_NickList.ResetContent();
		UpdateData(FALSE);
		GetDocument()->StopServer();
	}
	else
	{
		m_sSaid+="Server is already down....\r\n";
		UpdateData(FALSE);
	}
}




void CChatSView::ScrollEdit()
{
  int lines;
	lines=m_Said_control.GetLineCount();
	m_Said_control.LineScroll(lines,0);
	UpdateData(FALSE);
}
